﻿Imports RDSoft
Imports System.IO

Partial Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If IsPostBack = False Then
            '帳票作成を不可能にする
            excelPageContorolNomal.Enabled = False
            excelPageContorolBind.Enabled = False
            wordPageControlNomal.Enabled = False
            wordPageControlBind.Enabled = False
            excelLineContorolNomal.Enabled = False
            excelLineContorolBind.Enabled = False
        End If

    End Sub

    Protected Sub xmlread_Click(ByVal sender As Object, ByVal e As EventArgs) Handles xmlread.Click

        'XMLデータを読み込む（人口統計データ　5歳階級都道府県別）
        Dim ds As New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_5YEARGROUP.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledata As New DataTable()
        dtSampledata = ds.Tables(0)

        'XMLデータを読み込む（人口統計データ　登録されている年度）
        ds = New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_5YEARGROUP_NENDO.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledataNendo As New DataTable()
        dtSampledataNendo = ds.Tables(0)

        'XMLデータを読み込む（人口統計データ　登録されている都道府県）
        ds = New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_5YEARGROUP_TODOFUKEN.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledataTodofuken As New DataTable()
        dtSampledataTodofuken = ds.Tables(0)

        'XMLデータを読み込む（人口統計データ　都道府県別人口データ）
        ds = New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_TODOFUKEN_GROUP.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledataTodofukenGroup As New DataTable()
        dtSampledataTodofukenGroup = ds.Tables(0)

        'DataGridViewに表示（Bind)
        GridView1.DataSource = dtSampledata
        GridView1.DataBind()
        GridView2.DataSource = dtSampledataTodofukenGroup
        GridView2.DataBind()

        '年度DropDownList作成
        nendo.DataSource = dtSampledataNendo
        nendo.DataTextField = "NENDO"
        nendo.DataValueField = "NENDO"
        nendo.DataBind()
        nendo2.DataSource = dtSampledataNendo
        nendo2.DataTextField = "NENDO"
        nendo2.DataValueField = "NENDO"
        nendo2.DataBind()

        '都道府県名DropDownList作成
        todofuken.DataSource = dtSampledataTodofuken
        todofuken.DataTextField = "TODOFUKEN_MEI_K"
        todofuken.DataValueField = "TODOFUKEN_CD"
        todofuken.DataBind()

        '帳票作成を可能にする
        excelPageContorolNomal.Enabled = True
        excelPageContorolBind.Enabled = True
        wordPageControlNomal.Enabled = True
        wordPageControlBind.Enabled = False
        excelLineContorolNomal.Enabled = True
        excelLineContorolBind.Enabled = True

    End Sub

    Protected Sub excelPageContorolNomal_Click(ByVal sender As Object, ByVal e As EventArgs) Handles excelPageContorolNomal.Click

        ' データテーブルのクエリ・ソート処理
        '全国、都道府県単位のデータ抽出範囲の変更
        Dim qStr As String = ""

        If nendo.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        If todofuken.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        If todofuken.SelectedValue.ToString() = "00" Then
            '全国
            qStr = "NENDO='" + nendo.SelectedValue.ToString() + "'"
        Else
            '都道府県別
            qStr = "NENDO='" + nendo.SelectedValue.ToString() + "' AND TODOFUKEN_CD='" + todofuken.SelectedValue.ToString() + "'"
        End If

        'XMLデータを読み込む（人口統計データ　5歳階級都道府県別）
        Dim ds As New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_5YEARGROUP.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledata As New DataTable()
        dtSampledata = ds.Tables(0)

        '条件に応じてDataTableを抽出
        Dim db_TP5Y As DataTable = dtSampledata.Clone()
        Dim drQuery() As DataRow = dtSampledata.Select(qStr, "TODOFUKEN_CD,KUBUN2")
        For i = 0 To drQuery.Length - 1
            db_TP5Y.ImportRow(drQuery(i))
        Next

        'eDocuTool.net 通常記述
        Dim edoce As New eDocutool.Excel()
        If todofuken.SelectedValue.ToString() = "00" Then '全国

            '全国
            'excelPageContorol帳票作成
            '初期設定
            Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒
            Dim xlsxFileName As String = Server.MapPath("baseRepFile") + "\年齢性別一覧_symbol.xlsx" '帳票ファイル名
            Dim xlsxFileNameR As String = Server.MapPath("outRepFile") + "\年齢性別一覧_全国_" + now + ".xlsx" '出力帳票ファイル名
            Dim xlsxSheetName As String = "年齢別統計" 'シート名

            '帳票作成開始
            edoce.startPage(xlsxFileName)
            edoce.selectSheet(xlsxSheetName)

            'Excel内のラベルへデータ埋め込み
            For i = 0 To db_TP5Y.Rows.Count - 1

                If i Mod 18 = 0 Then

                    '18行出力毎に改ページ

                    edoce.setAddPage()

                    'CLIENTLOG_DBから展開
                    edoce.setFieldData("NENDO", nendo.SelectedValue.ToString())
                    edoce.setFieldData("TODOFUKEN_MEI_K", db_TP5Y.Rows(i)("TODOFUKEN_MEI_K").ToString())

                    '画像データの埋め込み
                    edoce.setPicData("symbol", Server.MapPath("todofuken_symbol") + "\" + db_TP5Y.Rows(i)("TODOFUKEN_CD").ToString() + ".gif")
                End If

                'Excel内のラベルへデータ埋め込み
                edoce.setFieldData("JINKO_M", Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_M")))
                edoce.setFieldData("JINKO_F", Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_F")))
            Next

            '帳票出力
            edoce.saveSheet()

            'ページ終了
            edoce.endPage(xlsxFileNameR)

        Else

            '都道府県別
            'excelPageContorol帳票作成
            '初期設定
            Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒
            Dim xlsxFileName As String = Server.MapPath("baseRepFile") + "\年齢性別一覧_symbol.xlsx" '帳票ファイル名
            Dim xlsxFileNameR As String = Server.MapPath("outRepFile") + "\年齢性別一覧_" + now + ".xlsx" '出力帳票ファイル名
            Dim xlsxSheetName As String = "年齢別統計" 'シート名

            '帳票作成開始
            edoce.startPage(xlsxFileName)
            edoce.selectSheet(xlsxSheetName)
            edoce.setAddPage()

            'CLIENTLOG_DBから展開
            edoce.setFieldData("NENDO", nendo.SelectedValue.ToString())
            edoce.setFieldData("TODOFUKEN_MEI_K", todofuken.SelectedItem.ToString())

            '画像データの埋め込み
            edoce.setPicData("symbol", Server.MapPath("todofuken_symbol") + "\" + todofuken.SelectedValue.ToString() + ".gif")

            'Excel内のラベルへデータ埋め込み
            For i = 0 To db_TP5Y.Rows.Count - 1
                edoce.setFieldData("JINKO_M", Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_M")))
                edoce.setFieldData("JINKO_F", Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_F")))
            Next

            '帳票出力
            edoce.saveSheet()

            'ページ終了
            edoce.endPage(xlsxFileNameR)
        End If

        'メッセージ
        result.Text = "帳票出力が完了しました。"
        filePath.Text = edoce.OutFilePath

        '解放
        db_TP5Y.Dispose()
        edoce = Nothing

    End Sub

    Protected Sub excelPageContorolBind_Click(ByVal sender As Object, ByVal e As EventArgs) Handles excelPageContorolBind.Click

        'データテーブルのクエリ・ソート処理
        '全国、都道府県単位のデータ抽出範囲の変更
        Dim qStr As String = ""

        If nendo.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        If todofuken.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        If todofuken.SelectedValue.ToString() = "00" Then
            '全国
            qStr = "NENDO='" + nendo.SelectedValue.ToString() + "'"
        Else
            '都道府県別
            qStr = "NENDO='" + nendo.SelectedValue.ToString() + "' AND TODOFUKEN_CD='" + todofuken.SelectedValue.ToString() + "'"
        End If

        'XMLデータを読み込む（人口統計データ　5歳階級都道府県別）
        Dim ds As New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_5YEARGROUP.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledata As New DataTable()
        dtSampledata = ds.Tables(0)

        '条件に応じてDataTableを抽出
        Dim db_TP5Y As DataTable = dtSampledata.Clone()
        Dim drQuery() As DataRow = dtSampledata.Select(qStr, "TODOFUKEN_CD,KUBUN2")
        For i = 0 To drQuery.Length - 1
            db_TP5Y.ImportRow(drQuery(i))
        Next

        'eDocuTool.net DataBind記述
        '初期設定
        Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒

        'バインド
        Dim eDocBinder As New eDocuToolDataBinder.Excel.PageControl()
        eDocBinder.sourceXlsxFileName = Server.MapPath("baseRepFile") + "\年齢性別一覧.xlsx" '帳票ファイル名
        eDocBinder.sourceXlsxSheetName = "年齢別統計" 'シート名
        eDocBinder.outputXlsxFileName = Server.MapPath("outRepFile") + "\年齢性別一覧_" + now + ".xlsx" '出力帳票ファイル名
        eDocBinder.ChangingPageConditionString = "NENDO,TODOFUKEN_CD" '改ページ条件
        eDocBinder.OmissionBindingColumns = True '処理効率化オプション
        eDocBinder.DataSource = db_TP5Y 'データソースとなるDataTable
        eDocBinder.DataBind() 'データバインド実行

        'メッセージ
        result.Text = "帳票出力が完了しました。"
        filePath.Text = eDocBinder.outputXlsxFileName

        '解放
        db_TP5Y.Dispose()
        eDocBinder = Nothing

    End Sub

    Protected Sub wordPageControlNomal_Click(ByVal sender As Object, ByVal e As EventArgs) Handles wordPageControlNomal.Click

        'データテーブルのクエリ・ソート処理
        '全国、都道府県単位のデータ抽出範囲の変更
        Dim qStr As String = ""

        If nendo.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        If todofuken.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        If todofuken.SelectedValue.ToString() = "00" Then
            '全国
            qStr = "NENDO='" + nendo.SelectedValue.ToString() + "'"
        Else
            '都道府県別
            qStr = "NENDO='" + nendo.SelectedValue.ToString() + "' AND TODOFUKEN_CD='" + todofuken.SelectedValue.ToString() + "'"
        End If

        'XMLデータを読み込む（人口統計データ　5歳階級都道府県別）
        Dim ds As New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_5YEARGROUP.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledata As New DataTable()
        dtSampledata = ds.Tables(0)

        '条件に応じてDataTableを抽出
        Dim db_TP5Y As DataTable = dtSampledata.Clone()
        Dim drQuery() As DataRow = dtSampledata.Select(qStr, "TODOFUKEN_CD,KUBUN2")
        For i = 0 To drQuery.Length - 1
            db_TP5Y.ImportRow(drQuery(i))
        Next

        'eDocuTool.net 通常記述
        Dim edocw = New eDocutool.Word()
        If todofuken.SelectedValue.ToString() = "00" Then '全国

            '都道府県別
            'wordPageContorol帳票作成
            '初期設定
            Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒
            Dim docxFileName As String = Server.MapPath("baseRepFile") + "\年齢性別一覧_symbol.docx" '帳票ファイル名
            Dim docxFileNameR As String = Server.MapPath("outRepFile") + "\年齢性別一覧_" + now + ".docx" '帳票ファイル名

            '帳票作成開始
            edocw.startPage(docxFileName)

            'Word内のラベルへデータ埋め込み
            For i = 0 To db_TP5Y.Rows.Count - 1

                If i Mod 18 = 0 Then

                    '18行出力毎に改ページ

                    edocw.setAddPage()

                    'CLIENTLOG_DBから展開
                    edocw.setTextData("#NENDO#", nendo.SelectedValue.ToString())
                    edocw.setTextData("#TODOFUKEN_MEI_K#", db_TP5Y.Rows(i)("TODOFUKEN_MEI_K").ToString())

                    '画像データの埋め込み
                    edocw.setPicData("symbol", Server.MapPath("todofuken_symbol") + "\" + db_TP5Y.Rows(i)("TODOFUKEN_CD").ToString() + ".gif")

                ElseIf i Mod 18 = 17 Then

                    '合計行計算と出力
                    Dim r As Integer = i - 1
                    Dim t_jinko_m As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", "TODOFUKEN_CD = '" + db_TP5Y.Rows(r)("TODOFUKEN_CD").ToString().PadLeft(2, "0") + "'"))
                    Dim t_jinko_f As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", "TODOFUKEN_CD = '" + db_TP5Y.Rows(r)("TODOFUKEN_CD").ToString().PadLeft(2, "0") + "'"))
                    Dim t_sum_jinko As Decimal = t_jinko_m + t_jinko_f
                    Dim t_per_jinko_m As Decimal = t_jinko_m / t_sum_jinko * 100
                    Dim t_per_jinko_f As Decimal = 100 - t_per_jinko_m

                    edocw.setTextData("#T_SUM_JINKO#", t_sum_jinko.ToString("#,##0"))
                    edocw.setTextData("#T_JINKO_M#", t_jinko_m.ToString("#,##0"))
                    edocw.setTextData("#T_JINKO_F#", t_jinko_f.ToString("#,##0"))
                    edocw.setTextData("#T_PER_JINKO_M#", t_per_jinko_m.ToString("#.0") + "%")
                    edocw.setTextData("#T_PER_JINKO_F#", t_per_jinko_f.ToString("#.0") + "%")

                End If

                'Word内のラベルへデータ埋め込み
                Dim jinko_m As Decimal = Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_M"))
                Dim jinko_f As Decimal = Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_F"))
                Dim sum_jinko As Decimal = jinko_m + jinko_f
                Dim per_jinko_m As Decimal = jinko_m / sum_jinko * 100
                Dim per_jinko_f As Decimal = 100 - per_jinko_m

                edocw.setTextData("#SUM_JINKO#", sum_jinko.ToString("#,##0"))
                edocw.setTextData("#JINKO_M#", jinko_m.ToString("#,##0"))
                edocw.setTextData("#JINKO_F#", jinko_f.ToString("#,##0"))
                edocw.setTextData("#PER_JINKO_M#", per_jinko_m.ToString("#.0") + "%")
                edocw.setTextData("#PER_JINKO_F#", per_jinko_f.ToString("#.0") + "%")
            Next

            'ページ終了
            edocw.endPage(docxFileNameR)

        Else
            '都道府県別
            'wordPageContorol帳票作成
            '初期設定
            Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒
            Dim docxFileName As String = Server.MapPath("baseRepFile") + "\年齢性別一覧_symbol.docx" '帳票ファイル名
            Dim docxFileNameR = Server.MapPath("outRepFile") + "\年齢性別一覧_" + now + ".docx" '帳票ファイル名

            '帳票作成開始
            edocw.startPage(docxFileName)

            'ページ追加
            edocw.setAddPage()

            'CLIENTLOG_DBから展開
            edocw.setTextData("#NENDO#", nendo.SelectedValue.ToString())
            edocw.setTextData("#TODOFUKEN_MEI_K#", todofuken.SelectedItem.ToString())

            '画像データの埋め込み
            edocw.setPicData("symbol", Server.MapPath("todofuken_symbol") + "\" + todofuken.SelectedValue.ToString() + ".gif")

            'Word内のラベルへデータ埋め込み
            For i = 0 To db_TP5Y.Rows.Count - 1
                Dim jinko_m As Decimal = Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_M"))
                Dim jinko_f As Decimal = Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_F"))
                Dim sum_jinko As Decimal = jinko_m + jinko_f
                Dim per_jinko_m As Decimal = jinko_m / sum_jinko
                Dim per_jinko_f As Decimal = 1 - per_jinko_m

                edocw.setTextData("#SUM_JINKO#", sum_jinko.ToString("#,##0"))
                edocw.setTextData("#JINKO_M#", jinko_m.ToString("#,##0"))
                edocw.setTextData("#JINKO_F#", jinko_f.ToString("#,##0"))
                edocw.setTextData("#PER_JINKO_M#", per_jinko_m.ToString("p1"))
                edocw.setTextData("#PER_JINKO_F#", per_jinko_f.ToString("p1"))
            Next

            '合計行計算と出力
            Dim t_jinko_m As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", ""))
            Dim t_jinko_f As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", ""))
            Dim t_sum_jinko As Decimal = t_jinko_m + t_jinko_f
            Dim t_per_jinko_m As Decimal = t_jinko_m / t_sum_jinko
            Dim t_per_jinko_f As Decimal = 1 - t_per_jinko_m

            edocw.setTextData("#T_SUM_JINKO#", t_sum_jinko.ToString("#,##0"))
            edocw.setTextData("#T_JINKO_M#", t_jinko_m.ToString("#,##0"))
            edocw.setTextData("#T_JINKO_F#", t_jinko_f.ToString("#,##0"))
            edocw.setTextData("#T_PER_JINKO_M#", t_per_jinko_m.ToString("p1"))
            edocw.setTextData("#T_PER_JINKO_F#", t_per_jinko_f.ToString("p1"))

            'ページ終了
            edocw.endPage(docxFileNameR)
        End If
        'メッセージ
        result.Text = "帳票出力が完了しました。"
        filePath.Text = edocw.OutFilePath

        '解放
        db_TP5Y.Dispose()
        edocw = Nothing

    End Sub

    Protected Sub wordPageControlBind_Click(ByVal sender As Object, ByVal e As EventArgs) Handles wordPageControlBind.Click

        ' データテーブルのクエリ・ソート処理
        '全国、都道府県単位のデータ抽出範囲の変更
        Dim qStr As String = ""

        If nendo.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        If todofuken.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        '都道府県別
        qStr = "NENDO='" + nendo.SelectedValue.ToString() + "' AND TODOFUKEN_CD='" + todofuken.SelectedValue.ToString() + "'"

        'XMLデータを読み込む（人口統計データ　5歳階級都道府県別）
        Dim ds As New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_5YEARGROUP.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledata As New DataTable()
        dtSampledata = ds.Tables(0)

        '条件に応じてDataTableを抽出
        Dim db_TP5Y As DataTable = dtSampledata.Clone()
        Dim drQuery() As DataRow = dtSampledata.Select(qStr, "TODOFUKEN_CD,KUBUN2")
        For i = 0 To drQuery.Length - 1
            db_TP5Y.ImportRow(drQuery(i))
        Next

        '明細の集計項目の追加
        db_TP5Y.Columns.Add("SUM_JINKO", GetType(Decimal))
        db_TP5Y.Columns.Add("PER_JINKO_M", GetType(String))
        db_TP5Y.Columns.Add("PER_JINKO_F", GetType(String))
        For i = 0 To db_TP5Y.Rows.Count - 1
            Dim jinko_m As Decimal = Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_M"))
            Dim jinko_f As Decimal = Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_F"))
            Dim sum_jinko As Decimal = jinko_m + jinko_f
            Dim per_jinko_m As Decimal = jinko_m / sum_jinko
            Dim per_jinko_f As Decimal = 1 - per_jinko_m
            db_TP5Y.Rows(i)("SUM_JINKO") = sum_jinko
            db_TP5Y.Rows(i)("PER_JINKO_M") = per_jinko_m.ToString("p1")
            db_TP5Y.Rows(i)("PER_JINKO_F") = per_jinko_f.ToString("p1")
        Next

        'eDocuTool.net DataBind記述
        '合計行集計とDataTable作成
        Dim db_TP5Y_TOTAL As New DataTable()
        db_TP5Y_TOTAL.Columns.Add("T_JINKO_M", GetType(Decimal))
        db_TP5Y_TOTAL.Columns.Add("T_JINKO_F", GetType(Decimal))
        db_TP5Y_TOTAL.Columns.Add("T_SUM_JINKO", GetType(Decimal))
        db_TP5Y_TOTAL.Columns.Add("T_PER_JINKO_M", GetType(String))
        db_TP5Y_TOTAL.Columns.Add("T_PER_JINKO_F", GetType(String))
        Dim dr As DataRow = db_TP5Y_TOTAL.NewRow()
        Dim t_jinko_m As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", ""))
        Dim t_jinko_f As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", ""))
        Dim t_sum_jinko As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)+SUM(JINKO_F)", ""))
        dr("T_JINKO_M") = t_jinko_m
        dr("T_JINKO_F") = t_jinko_f
        dr("T_SUM_JINKO") = t_sum_jinko
        dr("T_PER_JINKO_M") = (t_jinko_m / t_sum_jinko).ToString("p1")
        dr("T_PER_JINKO_F") = (1 - (t_jinko_m / t_sum_jinko)).ToString("p1")
        db_TP5Y_TOTAL.Rows.Add(dr)

        'DataSetにDataTableをまとめる
        Dim ds_TP5Y As New DataSet()
        ds_TP5Y.Tables.Add(db_TP5Y.Copy())
        ds_TP5Y.Tables.Add(db_TP5Y_TOTAL.Copy())

        '初期設定
        Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒

        'DataBind
        Dim eDocBinder As New eDocuToolDataBinder.Word.PageControl()
        eDocBinder.sourceDocxFileName = Server.MapPath("baseRepFile") + "\年齢性別一覧.docx" '帳票ファイル名
        eDocBinder.outputDocxFileName = Server.MapPath("outRepFile") + "\年齢性別一覧_" + now + ".docx" '帳票ファイル名
        eDocBinder.DataSource = ds_TP5Y
        eDocBinder.DataBind()

        'メッセージ
        result.Text = "帳票出力が完了しました。"
        filePath.Text = eDocBinder.outputDocxFileName

        '解放
        db_TP5Y.Dispose()
        db_TP5Y_TOTAL.Dispose()
        eDocBinder = Nothing

    End Sub

    Protected Sub excelLineContorolNomal_Click(ByVal sender As Object, ByVal e As EventArgs) Handles excelLineContorolNomal.Click

        'データテーブルのクエリ・ソート処理
        'データ抽出範囲の指定
        Dim qStr As String = ""

        If nendo2.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        qStr = "NENDO='" + nendo2.SelectedValue.ToString() + "'"

        'XMLデータを読み込む（人口統計データ　都道府県別人口データ）
        Dim ds As New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_TODOFUKEN_GROUP.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledataTodofukenGroup As New DataTable()
        dtSampledataTodofukenGroup = ds.Tables(0)

        '条件に応じてDataTableを抽出
        Dim db_TP5Y As DataTable = dtSampledataTodofukenGroup.Clone()
        Dim drQuery() As DataRow = dtSampledataTodofukenGroup.Select(qStr, "TODOFUKEN_CD")

        For i = 0 To drQuery.Length - 1
            db_TP5Y.ImportRow(drQuery(i))
        Next

        'eDocuTool.net 通常記述
        Dim edoce As New eDocutool.Excel()

        '初期設定
        Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒
        Dim xlsxFileName As String = Server.MapPath("baseRepFile") + "\都道府県別一覧.xlsx" '帳票ファイル名
        Dim xlsxSheetName As String = "都道府県別統計" 'シート名
        Dim xlsxFileNameR As String = Server.MapPath("outRepFile") + "\都道府県別統計_" + now + ".xlsx" 'シート名
        Dim startRow As Int32 = 8 '明細行開始位置
        Dim endRow As Int32 = 8 '明細行終了位置

        'ファイルとシートの選択
        edoce.startPage(xlsxFileName)
        edoce.selectSheetWithWriteLine(xlsxSheetName, startRow, endRow)

        'ヘッダー埋め込み
        edoce.setHeader()
        edoce.setFieldData("NENDO", nendo2.SelectedValue.ToString())

        'データ部分の埋め込み
        For i = 0 To db_TP5Y.Rows.Count - 1
            Dim sum_jinko As Decimal = Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_M")) + Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_F"))
            edoce.setAddLine()
            edoce.setFieldData("TODOFUKEN_MEI_K", db_TP5Y.Rows(i)("TODOFUKEN_MEI_K").ToString())
            edoce.setFieldData("JINKO_M", Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_M")))
            edoce.setFieldData("JINKO_F", Convert.ToDecimal(db_TP5Y.Rows(i)("JINKO_F")))
        Next

        '合計行計算と出力
        Dim t_jinko_m As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", ""))
        Dim t_jinko_f As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", ""))
        Dim t_sum_jinko As Decimal = t_jinko_m + t_jinko_f
        Dim t_per_jinko_m As Decimal = t_jinko_m / t_sum_jinko
        Dim t_per_jinko_f As Decimal = 1 - t_per_jinko_m

        edoce.setFooter()
        edoce.setFieldData("SUM_JINKO", t_sum_jinko)
        edoce.setFieldData("JINKO_M", t_jinko_m)
        edoce.setFieldData("JINKO_F", t_jinko_f)
        edoce.setFieldData("PER_JINKO_M", t_per_jinko_m)
        edoce.setFieldData("PER_JINKO_F", t_per_jinko_f)

        'ファイルとシートの処理終了
        edoce.saveSheet()
        edoce.endPage(xlsxFileNameR)

        'メッセージ
        result.Text = "帳票出力が完了しました。"
        filePath.Text = edoce.OutFilePath

        '解放
        db_TP5Y.Dispose()
        edoce = Nothing

    End Sub

    Protected Sub excelLineContorolBind_Click(ByVal sender As Object, ByVal e As EventArgs) Handles excelLineContorolBind.Click

        'データテーブルのクエリ・ソート処理
        'データ抽出範囲の指定
        Dim qStr As String = ""

        If nendo2.SelectedValue Is Nothing Then
            'メッセージ
            result.Text = "条件が選択されていません"
            Return
        End If

        qStr = "NENDO='" + nendo2.SelectedValue.ToString() + "'"

        'XMLデータを読み込む（人口統計データ　都道府県別人口データ）
        Dim ds As New DataSet()
        ds.ReadXml(Server.MapPath("xmldata") + "\TOTAL_POPULATION_TODOFUKEN_GROUP.xml", XmlReadMode.Auto)
        'データテーブルに格納
        Dim dtSampledataTodofukenGroup As New DataTable()
        dtSampledataTodofukenGroup = ds.Tables(0)

        '条件に応じてDataTableを抽出
        Dim db_TP5Y As DataTable = dtSampledataTodofukenGroup.Clone()
        Dim drQuery() As DataRow = dtSampledataTodofukenGroup.Select(qStr, "TODOFUKEN_CD")
        For i = 0 To drQuery.Length - 1
            db_TP5Y.ImportRow(drQuery(i))
        Next

        'eDocuTool.net DataBind記述
        '初期設定
        Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒

        '最終集計行の作成
        Dim db_TP5Y_TOTAL As DataTable = db_TP5Y.Clone() 'フッター用合計DataTable
        db_TP5Y_TOTAL.Columns.Add("SUM_JINKO", GetType(Decimal))
        db_TP5Y_TOTAL.Columns.Add("PER_JINKO_M", GetType(Decimal))
        db_TP5Y_TOTAL.Columns.Add("PER_JINKO_F", GetType(Decimal))

        'フッター集計行のDataTable作成
        Dim drF As DataRow = db_TP5Y_TOTAL.NewRow()
        Dim t_jinko_m As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", ""))
        Dim t_jinko_f As Decimal = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", ""))
        Dim t_sum_jinko As Decimal = t_jinko_m + t_jinko_f
        Dim t_per_jinko_m As Decimal = t_jinko_m / t_sum_jinko
        Dim t_per_jinko_f As Decimal = 1 - t_per_jinko_m
        drF("JINKO_M") = t_jinko_m
        drF("JINKO_F") = t_jinko_f
        drF("SUM_JINKO") = t_sum_jinko
        drF("PER_JINKO_M") = t_per_jinko_m
        drF("PER_JINKO_F") = t_per_jinko_f
        db_TP5Y_TOTAL.Rows.Add(drF)

        'バインド
        Dim eDocBinder As New eDocuToolDataBinder.Excel.LineControl()
        eDocBinder.sourceXlsxFileName = Server.MapPath("baseRepFile") + "\都道府県別一覧.xlsx" '帳票ファイル名
        eDocBinder.sourceXlsxSheetName = "都道府県別統計" 'シート名
        eDocBinder.outputXlsxFileName = Server.MapPath("outRepFile") + "\都道府県別統計_" + now + ".xlsx" 'シート名
        eDocBinder.startDetailRow = 8 '明細行開始位置
        eDocBinder.endDetailRow = 8 '明細行終了位置
        eDocBinder.HeaderDataSource = db_TP5Y 'ヘッダー用DataTable
        eDocBinder.DetailDataSource = db_TP5Y '明細用DataTable
        eDocBinder.FooterDataSource = db_TP5Y_TOTAL 'フッター用DataTable
        eDocBinder.DataBind() 'データバインド

        'メッセージ
        result.Text = "帳票出力が完了しました。"
        filePath.Text = eDocBinder.outputXlsxFileName

        '解放
        db_TP5Y.Dispose()
        db_TP5Y_TOTAL.Dispose()
        eDocBinder = Nothing

    End Sub

    Protected Sub wordPageControlTextChange_Click(ByVal sender As Object, ByVal e As EventArgs) Handles wordPageControlTextChange.Click

        Dim edocw As New eDocutool.Word()

        'wordPageContorol文書作成
        '初期設定
        Dim now As String = DateTime.Now.ToString("yyyyMMddHHmmssfffffff") '出力ファイルをユニークにするための年月日時分秒
        Dim docxFileName As String = Server.MapPath("baseRepFile") + "\soft-kaihatsu.docx" '文書ファイル名
        Dim docxFileNameR As String = Server.MapPath("outRepFile") + "\soft-kaihatsu_" + now + ".docx" '文書ファイル名

        '文書作成開始
        edocw.startPage(docxFileName)

        'ページ開始
        edocw.setAddPage()

        'Word文書内の文字置換処理
        If target.Text <> "" Then
            edocw.setTextDataAll(target.Text, changeText.Text)
        End If

        'ページ終了
        edocw.endPage(docxFileNameR)

        'メッセージ
        result.Text = "文書出力が完了しました。"
        filePath.Text = edocw.OutFilePath

        '解放
        edocw = Nothing

    End Sub

    Protected Sub fileOpen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles fileOpen.Click

        '
        '作成したファイルを開く処理
        '

        'テキストボックス文字列のチェック
        If filePath.Text <> "" Then
            Dim fi As FileInfo = New FileInfo(filePath.Text)
            If fi.Exists Then
                Process.Start(fi.FullName)
            End If
        End If
    End Sub

    Protected Sub todofuken_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles todofuken.SelectedIndexChanged
        If todofuken.SelectedValue = "00" Then
            wordPageControlBind.Enabled = False
        Else
            wordPageControlBind.Enabled = True
        End If

    End Sub
End Class