﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;
using RDSoft;

namespace sample_edocutool
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        DataTable dtSampledata = new DataTable();
        DataTable dtSampledataNendo = new DataTable();
        DataTable dtSampledataTodofuken = new DataTable();
        DataTable dtSampledataTodofukenGroup = new DataTable();

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            //帳票作成を不可能にする
            excelPageContorolNomal.Enabled = false;
            excelPageContorolBind.Enabled = false;
            wordPageControlNomal.Enabled = false;
            wordPageControlBind.Enabled = false;
            excelLineContorolNomal.Enabled = false;
            excelLineContorolBind.Enabled = false;
        }

        #region XMLデータの読み込み
        /// <summary>
        /// XMLデータの読み込み
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void xmlread_Click(object sender, EventArgs e)
        {
            //XMLデータを読み込む（人口統計データ　5歳階級都道府県別）
            DataSet ds = new DataSet();
            ds.ReadXml(@"..\..\xmldata\TOTAL_POPULATION_5YEARGROUP.xml", XmlReadMode.Auto);
            //データテーブルに格納
            dtSampledata = ds.Tables[0];

            //XMLデータを読み込む（人口統計データ　登録されている年度）
            ds = new DataSet();
            ds.ReadXml(@"..\..\xmldata\TOTAL_POPULATION_5YEARGROUP_NENDO.xml", XmlReadMode.Auto);
            //データテーブルに格納
            dtSampledataNendo = ds.Tables[0];

            //XMLデータを読み込む（人口統計データ　登録されている都道府県）
            ds = new DataSet();
            ds.ReadXml(@"..\..\xmldata\TOTAL_POPULATION_5YEARGROUP_TODOFUKEN.xml", XmlReadMode.Auto);
            //データテーブルに格納
            dtSampledataTodofuken = ds.Tables[0];

            //XMLデータを読み込む（人口統計データ　都道府県別人口データ）
            ds = new DataSet();
            ds.ReadXml(@"..\..\xmldata\TOTAL_POPULATION_TODOFUKEN_GROUP.xml", XmlReadMode.Auto);
            //データテーブルに格納
            dtSampledataTodofukenGroup = ds.Tables[0];


            //DataGridViewに表示（Bind)
            dataGridView1.DataSource = dtSampledata;
            dataGridView2.DataSource = dtSampledataTodofukenGroup;

            //年度Combobox作成
            nendo.DisplayMember = "NENDO";
            nendo.ValueMember = "NENDO";
            nendo.DataSource = dtSampledataNendo;
            nendo2.DisplayMember = "NENDO";
            nendo2.ValueMember = "NENDO";
            nendo2.DataSource = dtSampledataNendo;

            //都道府県名Combobox作成
            todofuken.DisplayMember = "TODOFUKEN_MEI_K";
            todofuken.ValueMember = "TODOFUKEN_CD";
            todofuken.DataSource = dtSampledataTodofuken;

            //帳票作成を可能にする
            excelPageContorolNomal.Enabled = true;
            excelPageContorolBind.Enabled = true;
            wordPageControlNomal.Enabled = true;
            wordPageControlBind.Enabled = false;
            excelLineContorolNomal.Enabled = true;
            excelLineContorolBind.Enabled = true;

        }
        #endregion

        /// <summary>
        /// Excel PageContorol 通常記述 サンプル
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void excelPageContorolNomal_Click(object sender, EventArgs e)
        {
            #region データテーブルのクエリ・ソート処理

            //全国、都道府県単位のデータ抽出範囲の変更
            string qStr = "";
            if (nendo.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }
            if (todofuken.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }
            if (todofuken.SelectedValue.ToString() == "00")
            {
                //全国
                qStr = "NENDO='" + nendo.SelectedValue.ToString() + "'";
            }
            else
            {
                //都道府県別
                qStr = "NENDO='" + nendo.SelectedValue.ToString() + "' AND TODOFUKEN_CD='" + todofuken.SelectedValue.ToString() + "'";
            }

            //条件に応じてDataTableを抽出
            DataTable db_TP5Y = dtSampledata.Clone();
            DataRow[] drQuery = dtSampledata.Select(qStr, "TODOFUKEN_CD,KUBUN2");
            for (int i = 0; i < drQuery.Length; i++)
            {
                db_TP5Y.ImportRow(drQuery[i]);
            }

            #endregion

            #region eDocuTool.net 通常記述

            eDocutool.Excel edoce = new eDocutool.Excel();

            if (todofuken.SelectedValue.ToString() == "00")//全国
            {
                //全国

                //excelPageContorol帳票作成
                //初期設定
                string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒
                string xlsxFileName = @"..\..\baseRepFile\年齢性別一覧_symbol.xlsx";//帳票ファイル名
                string xlsxFileNameR = @"..\..\outRepFile\年齢性別一覧_全国_" + now + ".xlsx";//出力帳票ファイル名
                string xlsxSheetName = "年齢別統計";//シート名

                //帳票作成開始
                edoce.startPage(xlsxFileName);
                edoce.selectSheet(xlsxSheetName);

                //Excel内のラベルへデータ埋め込み
                for (int i = 0; i < db_TP5Y.Rows.Count; i++)
                {
                    if (i % 18 == 0)
                    {
                        //18行出力毎に改ページ
                        edoce.setAddPage();

                        //CLIENTLOG_DBから展開
                        edoce.setTextData("NENDO", nendo.SelectedValue.ToString());
                        edoce.setFieldData("TODOFUKEN_MEI_K", db_TP5Y.Rows[i]["TODOFUKEN_MEI_K"].ToString());

                        //画像データの埋め込み
                        edoce.setPicData("symbol", @"..\..\todofuken_symbol\" + db_TP5Y.Rows[i]["TODOFUKEN_CD"].ToString() + ".gif");
                    }

                    edoce.setFieldData("JINKO_M", Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_M"]));
                    edoce.setFieldData("JINKO_F", Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_F"]));
                }

                //帳票出力
                edoce.saveSheet();

                //ページ終了
                edoce.endPage(xlsxFileNameR);
            }
            else
            {
                //都道府県別

                //excelPageContorol帳票作成
                //初期設定
                string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒
                string xlsxFileName = @"..\..\baseRepFile\年齢性別一覧_symbol.xlsx";//帳票ファイル名
                string xlsxFileNameR = @"..\..\outRepFile\年齢性別一覧_" + now + ".xlsx";//出力帳票ファイル名
                string xlsxSheetName = "年齢別統計";//シート名


                //帳票作成開始
                edoce.startPage(xlsxFileName);
                edoce.selectSheet(xlsxSheetName);
                edoce.setAddPage();

                //CLIENTLOG_DBから展開
                edoce.setTextData("NENDO", nendo.SelectedValue.ToString());
                edoce.setFieldData("TODOFUKEN_MEI_K", todofuken.Text);

                //画像データの埋め込み
                edoce.setPicData("symbol", @"..\..\todofuken_symbol\" + todofuken.SelectedValue.ToString() + ".gif");

                //Excel内のラベルへデータ埋め込み
                for (int i = 0; i < db_TP5Y.Rows.Count; i++)
                {
                    edoce.setFieldData("JINKO_M", Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_M"]));
                    edoce.setFieldData("JINKO_F", Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_F"]));
                }

                //帳票出力
                edoce.saveSheet();

                //ページ終了
                edoce.endPage(xlsxFileNameR);
            }

            #endregion

            //メッセージ
            result.Text = "帳票出力が完了しました。";
            filePath.Text = edoce.OutFilePath;

            //解放
            db_TP5Y.Dispose();
            edoce = null;
        }

        /// <summary>
        /// Excel PageContorol DataBinder サンプル
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void excelPageContorolBind_Click(object sender, EventArgs e)
        {
            #region データテーブルのクエリ・ソート処理

            //全国、都道府県単位のデータ抽出範囲の変更
            string qStr = "";
            if (nendo.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }
            if (todofuken.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }
            if (todofuken.SelectedValue.ToString() == "00")
            {
                //全国
                qStr = "NENDO='" + nendo.SelectedValue.ToString() + "'";
            }
            else
            {
                //都道府県別
                qStr = "NENDO='" + nendo.SelectedValue.ToString() + "' AND TODOFUKEN_CD='" + todofuken.SelectedValue.ToString() + "'";
            }

            //条件に応じてDataTableを抽出
            DataTable db_TP5Y = dtSampledata.Clone();
            DataRow[] drQuery = dtSampledata.Select(qStr, "TODOFUKEN_CD,KUBUN2");
            for (int i = 0; i < drQuery.Length; i++)
            {
                db_TP5Y.ImportRow(drQuery[i]);
            }

            #endregion

            #region eDocuTool.net DataBind記述

            //初期設定
            string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒

            //バインド
            eDocuToolDataBinder.Excel.PageControl eDocBinder = new eDocuToolDataBinder.Excel.PageControl();
            eDocBinder.sourceXlsxFileName = @"..\..\baseRepFile\年齢性別一覧.xlsx";//帳票ファイル名
            eDocBinder.sourceXlsxSheetName = "年齢別統計";//シート名
            eDocBinder.outputXlsxFileName = @"..\..\outRepFile\年齢性別一覧_" + now + ".xlsx";//出力帳票ファイル名
            //eDocBinder.ChangingPageRowCount = 18;
            eDocBinder.ChangingPageConditionString = "NENDO,TODOFUKEN_CD";//改ページ条件
            eDocBinder.OmissionBindingColumns = true;//処理効率化オプション
            eDocBinder.DataSource = db_TP5Y;//データソースとなるDataTable
            eDocBinder.DataBind();//データバインド実行

            #endregion

            //メッセージ
            result.Text = "帳票出力が完了しました。";
            filePath.Text = eDocBinder.outputXlsxFileName;

            //解放
            db_TP5Y.Dispose();
            eDocBinder = null;
        }

        /// <summary>
        /// Word PageContorol 通常記述 サンプル
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void wordPageControlNomal_Click(object sender, EventArgs e)
        {
            #region データテーブルのクエリ・ソート処理

            //全国、都道府県単位のデータ抽出範囲の変更
            string qStr = "";
            if (nendo.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }
            if (todofuken.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }
            if (todofuken.SelectedValue.ToString() == "00")
            {
                //全国
                //wordPageContorol帳票作成
                //改ページ完成待ち
                qStr = "NENDO='" + nendo.SelectedValue.ToString() + "'";
            }
            else
            {
                //都道府県別
                qStr = "NENDO='" + nendo.SelectedValue.ToString() + "' AND TODOFUKEN_CD='" + todofuken.SelectedValue.ToString() + "'";
            }

            //条件に応じてDataTableを抽出
            DataTable db_TP5Y = dtSampledata.Clone();
            DataRow[] drQuery = dtSampledata.Select(qStr, "TODOFUKEN_CD,KUBUN2");
            for (int i = 0; i < drQuery.Length; i++)
            {
                db_TP5Y.ImportRow(drQuery[i]);
            }

            #endregion

            #region eDocuTool.net 通常記述

            eDocutool.Word edocw = new eDocutool.Word();

            if (todofuken.SelectedValue.ToString() == "00")//全国
            {
                //全国

                //wordPageContorol帳票作成
                //初期設定
                string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒
                string docxFileName = @"..\..\baseRepFile\年齢性別一覧_symbol.docx";//帳票ファイル名
                string docxFileNameR = @"..\..\outRepFile\年齢性別一覧_全国_" + now + ".docx";//出力帳票ファイル名

                //帳票作成開始
                edocw.startPage(docxFileName);
                
                //Word内のラベルへデータ埋め込み
                for (int i = 0; i < db_TP5Y.Rows.Count; i++)
                {
                    if (i % 18 == 0)
                    {
                        //18行出力毎に改ページ

                        edocw.setAddPage();

                        //CLIENTLOG_DBから展開
                        edocw.setTextData("#NENDO#", nendo.SelectedValue.ToString());
                        edocw.setTextData("#TODOFUKEN_MEI_K#", db_TP5Y.Rows[i]["TODOFUKEN_MEI_K"].ToString());

                        ///画像データの埋め込み
                        edocw.setPicData("symbol", @"..\..\todofuken_symbol\" + db_TP5Y.Rows[i]["TODOFUKEN_CD"].ToString() + ".gif");
                    }
                    else if (i % 18 == 17)
                    {
                        //合計行計算と出力
                        int r = i - 1;
                        decimal t_jinko_m = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", "TODOFUKEN_CD = '" + db_TP5Y.Rows[r]["TODOFUKEN_CD"].ToString().PadLeft(2, '0') + "'"));
                        decimal t_jinko_f = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", "TODOFUKEN_CD = '" + db_TP5Y.Rows[r]["TODOFUKEN_CD"].ToString().PadLeft(2, '0') + "'"));
                        decimal t_sum_jinko = t_jinko_m + t_jinko_f;
                        decimal t_per_jinko_m = t_jinko_m / t_sum_jinko * 100;
                        decimal t_per_jinko_f = 100 - t_per_jinko_m;

                        edocw.setTextData("#T_SUM_JINKO#", t_sum_jinko.ToString("#,##0"));
                        edocw.setTextData("#T_JINKO_M#", t_jinko_m.ToString("#,##0"));
                        edocw.setTextData("#T_JINKO_F#", t_jinko_f.ToString("#,##0"));
                        edocw.setTextData("#T_PER_JINKO_M#", t_per_jinko_m.ToString("#.0") + "%");
                        edocw.setTextData("#T_PER_JINKO_F#", t_per_jinko_f.ToString("#.0") + "%");
                    }
                    
                    decimal jinko_m = Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_M"]);
                    decimal jinko_f = Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_F"]);
                    decimal sum_jinko = jinko_m + jinko_f;
                    decimal per_jinko_m = jinko_m / sum_jinko * 100;
                    decimal per_jinko_f = 100 - per_jinko_m;

                    edocw.setTextData("#SUM_JINKO#", sum_jinko.ToString("#,##0"));
                    edocw.setTextData("#JINKO_M#", jinko_m.ToString("#,##0"));
                    edocw.setTextData("#JINKO_F#", jinko_f.ToString("#,##0"));
                    edocw.setTextData("#PER_JINKO_M#", per_jinko_m.ToString("#.0") + "%");
                    edocw.setTextData("#PER_JINKO_F#", per_jinko_f.ToString("#.0") + "%");
                }

                //ページ終了
                edocw.endPage(docxFileNameR);
            }

            else
            {
                //都道府県別

                //wordPageContorol帳票作成
                //初期設定
                string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒
                string docxFileName = @"..\..\baseRepFile\年齢性別一覧_symbol.docx";//帳票ファイル名
                string docxFileNameR = @"..\..\outRepFile\年齢性別一覧_" + now + ".docx";//出力帳票ファイル名

                //帳票作成開始
                edocw.startPage(docxFileName);
                edocw.setAddPage();

                //CLIENTLOG_DBから展開
                edocw.setTextData("#NENDO#", nendo.SelectedValue.ToString());
                edocw.setTextData("#TODOFUKEN_MEI_K#", todofuken.Text);

                ///画像データの埋め込み
                edocw.setPicData("symbol", @"..\..\todofuken_symbol\" + todofuken.SelectedValue.ToString() + ".gif");

                //Word内のラベルへデータ埋め込み
                for (int i = 0; i < db_TP5Y.Rows.Count; i++)
                {
                    decimal jinko_m = Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_M"]);
                    decimal jinko_f = Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_F"]);
                    decimal sum_jinko = jinko_m + jinko_f;
                    decimal per_jinko_m = jinko_m / sum_jinko * 100;
                    decimal per_jinko_f = 100 - per_jinko_m;

                    edocw.setTextData("#SUM_JINKO#", sum_jinko.ToString("#,##0"));
                    edocw.setTextData("#JINKO_M#", jinko_m.ToString("#,##0"));
                    edocw.setTextData("#JINKO_F#", jinko_f.ToString("#,##0"));
                    edocw.setTextData("#PER_JINKO_M#", per_jinko_m.ToString("#.0") + "%");
                    edocw.setTextData("#PER_JINKO_F#", per_jinko_f.ToString("#.0") + "%");
                }

                //合計行計算と出力
                decimal t_jinko_m = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", ""));
                decimal t_jinko_f = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", ""));
                decimal t_sum_jinko = t_jinko_m + t_jinko_f;
                decimal t_per_jinko_m = t_jinko_m / t_sum_jinko * 100;
                decimal t_per_jinko_f = 100 - t_per_jinko_m;

                edocw.setTextData("#T_SUM_JINKO#", t_sum_jinko.ToString("#,##0"));
                edocw.setTextData("#T_JINKO_M#", t_jinko_m.ToString("#,##0"));
                edocw.setTextData("#T_JINKO_F#", t_jinko_f.ToString("#,##0"));
                edocw.setTextData("#T_PER_JINKO_M#", t_per_jinko_m.ToString("#.0") + "%");
                edocw.setTextData("#T_PER_JINKO_F#", t_per_jinko_f.ToString("#.0") + "%");

                //ページ終了
                edocw.endPage(docxFileNameR);
            }

            #endregion

            //メッセージ
            result.Text = "帳票出力が完了しました。";
            filePath.Text = edocw.OutFilePath;

            //解放
            db_TP5Y.Dispose();
            edocw = null;
        }

        /// <summary>
        /// Word PageContorol DataBinder サンプル
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void wordPageControlBind_Click(object sender, EventArgs e)
        {
            #region データテーブルのクエリ・ソート処理

            //全国、都道府県単位のデータ抽出範囲の変更
            string qStr = "";
            if (nendo.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }
            if (todofuken.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }
            if (todofuken.SelectedValue.ToString() == "00")
            {
                //全国
                //wordPageContorolBind帳票作成
                //改ページ完成待ち
                qStr = "NENDO='" + nendo.SelectedValue.ToString() + "'";
            }
            else
            {
                //都道府県別
                qStr = "NENDO='" + nendo.SelectedValue.ToString() + "' AND TODOFUKEN_CD='" + todofuken.SelectedValue.ToString() + "'";
            }

            //条件に応じてDataTableを抽出
            DataTable db_TP5Y = dtSampledata.Clone();
            DataRow[] drQuery = dtSampledata.Select(qStr, "TODOFUKEN_CD,KUBUN2");
            for (int i = 0; i < drQuery.Length; i++)
            {
                db_TP5Y.ImportRow(drQuery[i]);
            }

            //明細の集計項目の追加
            db_TP5Y.Columns.Add("SUM_JINKO",typeof(decimal));
            db_TP5Y.Columns.Add("PER_JINKO_M", typeof(string));
            db_TP5Y.Columns.Add("PER_JINKO_F", typeof(string));
            for (int i = 0; i < db_TP5Y.Rows.Count; i++)
            {
                decimal jinko_m = Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_M"]);
                decimal jinko_f = Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_F"]);
                decimal sum_jinko = jinko_m + jinko_f;
                decimal per_jinko_m = jinko_m / sum_jinko;
                decimal per_jinko_f = 1 - per_jinko_m;
                db_TP5Y.Rows[i]["SUM_JINKO"] = sum_jinko;
                db_TP5Y.Rows[i]["PER_JINKO_M"] = per_jinko_m.ToString("#.0" + "%");
                db_TP5Y.Rows[i]["PER_JINKO_F"] = per_jinko_f.ToString("#.0" + "%");
            }
            #endregion

            #region eDocuTool.net DataBind記述

            //合計行集計とDataTable作成
            DataTable db_TP5Y_TOTAL = new DataTable();
            db_TP5Y_TOTAL.Columns.Add("T_JINKO_M", typeof(decimal));
            db_TP5Y_TOTAL.Columns.Add("T_JINKO_F", typeof(decimal));
            db_TP5Y_TOTAL.Columns.Add("T_SUM_JINKO", typeof(decimal));
            db_TP5Y_TOTAL.Columns.Add("T_PER_JINKO_M", typeof(string));
            db_TP5Y_TOTAL.Columns.Add("T_PER_JINKO_F", typeof(string));
            DataRow dr = db_TP5Y_TOTAL.NewRow();
            decimal t_jinko_m = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", ""));
            decimal t_jinko_f = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", ""));
            decimal t_sum_jinko = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)+SUM(JINKO_F)", ""));
            dr["T_JINKO_M"] = t_jinko_m;
            dr["T_JINKO_F"] = t_jinko_f;
            dr["T_SUM_JINKO"] = t_sum_jinko;
            dr["T_PER_JINKO_M"] = (t_jinko_m / t_sum_jinko).ToString("#.0" + "%");
            dr["T_PER_JINKO_F"] = (1 - (t_jinko_m / t_sum_jinko)).ToString("#.0" + "%");
            db_TP5Y_TOTAL.Rows.Add(dr);

            //DataSetにDataTableをまとめる
            DataSet ds_TP5Y = new DataSet();
            ds_TP5Y.Tables.Add(db_TP5Y.Copy());
            ds_TP5Y.Tables.Add(db_TP5Y_TOTAL.Copy());

            //初期設定
            string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒

            //DataBind
            eDocuToolDataBinder.Word.PageControl eDocBinder = new eDocuToolDataBinder.Word.PageControl();
            eDocBinder.sourceDocxFileName = @"..\..\baseRepFile\年齢性別一覧.docx";//帳票ファイル名
            eDocBinder.outputDocxFileName = @"..\..\outRepFile\年齢性別一覧_" + now + ".docx";//出力帳票ファイル名
            eDocBinder.DataSource = ds_TP5Y;
            eDocBinder.DataBind();

            #endregion

            //メッセージ
            result.Text = "帳票出力が完了しました。";
            filePath.Text = eDocBinder.outputDocxFileName;

            //解放
            db_TP5Y.Dispose();
            db_TP5Y_TOTAL.Dispose();
            eDocBinder = null;
        }

        /// <summary>
        /// Excel LineContorol 通常記述 サンプル
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void excelLineContorolNomal_Click(object sender, EventArgs e)
        {
            #region データテーブルのクエリ・ソート処理

            //データ抽出範囲の指定
            string qStr = "";
            if (nendo2.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }

            qStr = "NENDO='" + nendo2.SelectedValue.ToString() + "'";

            //条件に応じてDataTableを抽出
            DataTable db_TP5Y = dtSampledataTodofukenGroup.Clone();
            DataRow[] drQuery = dtSampledataTodofukenGroup.Select(qStr, "TODOFUKEN_CD");
            for (int i = 0; i < drQuery.Length; i++)
            {
                db_TP5Y.ImportRow(drQuery[i]);
            }

            #endregion

            #region eDocuTool.net 通常記述

            eDocutool.Excel edoce = new eDocutool.Excel();

            ////初期設定
            string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒
            string xlsxFileName = @"..\..\baseRepFile\都道府県別一覧.xlsx";//帳票ファイル名
            string xlsxSheetName = "都道府県別統計";//シート名
            string xlsxFileNameR = @"..\..\outRepFile\都道府県別統計_" + now + ".xlsx";//出力帳票ファイル名
            int startRow = 8;//明細行開始位置
            int endRow = 8;//明細行終了位置

            //ファイルとシートの選択
            edoce.startPage(xlsxFileName);
            edoce.selectSheetWithWriteLine(xlsxSheetName, startRow, endRow);

            //ヘッダー埋め込み
            edoce.setHeader();
            edoce.setFieldData("NENDO", nendo2.SelectedValue.ToString());

            //データ部分の埋め込み
            for (int i = 0; i < db_TP5Y.Rows.Count; i++)
            {
                decimal sum_jinko = Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_M"]) + Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_F"]);
                edoce.setAddLine();
                edoce.setFieldData("TODOFUKEN_MEI_K", db_TP5Y.Rows[i]["TODOFUKEN_MEI_K"].ToString());
                edoce.setFieldData("JINKO_M", Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_M"]));
                edoce.setFieldData("JINKO_F", Convert.ToDecimal(db_TP5Y.Rows[i]["JINKO_F"]));
            }

            //合計行計算と出力
            decimal t_jinko_m = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", ""));
            decimal t_jinko_f = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", ""));
            decimal t_sum_jinko = t_jinko_m + t_jinko_f;
            decimal t_per_jinko_m = t_jinko_m / t_sum_jinko;
            decimal t_per_jinko_f = 1 - t_per_jinko_m;

            edoce.setFooter();
            edoce.setFieldData("SUM_JINKO", t_sum_jinko);
            edoce.setFieldData("JINKO_M", t_jinko_m);
            edoce.setFieldData("JINKO_F", t_jinko_f);
            edoce.setFieldData("PER_JINKO_M", t_per_jinko_m);
            edoce.setFieldData("PER_JINKO_F", t_per_jinko_f);

            //ファイルとシートの処理終了
            edoce.saveSheet();
            edoce.endPage(xlsxFileNameR);

            #endregion

            //メッセージ
            result.Text = "帳票出力が完了しました。";
            filePath.Text = edoce.OutFilePath;

            //解放
            db_TP5Y.Dispose();
            edoce = null;
        }

        /// <summary>
        /// Excel LineContorol DataBind記述 サンプル
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void excelLineContorolBind_Click(object sender, EventArgs e)
        {
            #region データテーブルのクエリ・ソート処理

            //データ抽出範囲の指定
            string qStr = "";
            if (nendo2.SelectedValue == null)
            {
                //メッセージ
                result.Text = "条件が選択されていません";
                return;
            }

            qStr = "NENDO='" + nendo2.SelectedValue.ToString() + "'";

            //条件に応じてDataTableを抽出
            DataTable db_TP5Y = dtSampledataTodofukenGroup.Clone();
            DataRow[] drQuery = dtSampledataTodofukenGroup.Select(qStr, "TODOFUKEN_CD");
            for (int i = 0; i < drQuery.Length; i++)
            {
                db_TP5Y.ImportRow(drQuery[i]);
            }

            #endregion

            #region eDocuTool.net DataBind記述

            //初期設定
            string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒

            //最終集計行の作成
            DataTable db_TP5Y_TOTAL = db_TP5Y.Clone();//フッター用合計DataTable
            db_TP5Y_TOTAL.Columns.Add("SUM_JINKO", typeof(decimal));
            db_TP5Y_TOTAL.Columns.Add("PER_JINKO_M", typeof(decimal));
            db_TP5Y_TOTAL.Columns.Add("PER_JINKO_F", typeof(decimal));

            //フッター集計行のDataTable作成
            DataRow drF = db_TP5Y_TOTAL.NewRow();
            decimal t_jinko_m = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_M)", ""));
            decimal t_jinko_f = Convert.ToDecimal(db_TP5Y.Compute("SUM(JINKO_F)", ""));
            decimal t_sum_jinko = t_jinko_m + t_jinko_f;
            decimal t_per_jinko_m = t_jinko_m / t_sum_jinko;
            decimal t_per_jinko_f = 1 - t_per_jinko_m;
            drF["JINKO_M"] = t_jinko_m;
            drF["JINKO_F"] = t_jinko_f;
            drF["SUM_JINKO"] = t_sum_jinko;
            drF["PER_JINKO_M"] = t_per_jinko_m;
            drF["PER_JINKO_F"] = t_per_jinko_f;
            db_TP5Y_TOTAL.Rows.Add(drF);

            //バインド
            eDocuToolDataBinder.Excel.LineControl eDocBinder = new eDocuToolDataBinder.Excel.LineControl();
            eDocBinder.sourceXlsxFileName = @"..\..\baseRepFile\都道府県別一覧.xlsx";//帳票ファイル名
            eDocBinder.sourceXlsxSheetName = "都道府県別統計";//シート名
            eDocBinder.outputXlsxFileName = @"..\..\outRepFile\都道府県別統計_" + now + ".xlsx";//出力帳票ファイル名
            eDocBinder.startDetailRow = 8;//明細行開始位置
            eDocBinder.endDetailRow = 8;//明細行終了位置
            eDocBinder.HeaderDataSource = db_TP5Y;//ヘッダー用DataTable
            eDocBinder.DetailDataSource = db_TP5Y;//明細用DataTable
            eDocBinder.FooterDataSource = db_TP5Y_TOTAL;//フッター用DataTable
            eDocBinder.DataBind();//データバインド

            #endregion

            //メッセージ
            result.Text = "帳票出力が完了しました。";
            filePath.Text = eDocBinder.outputXlsxFileName;

            //解放
            db_TP5Y.Dispose();
            db_TP5Y_TOTAL.Dispose();
            eDocBinder = null;
        }

        /// <summary>
        /// Word PageControlTextChange記述　サンプル
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void wordPageControlTextChange_Click(object sender, EventArgs e)
        {
            eDocutool.Word edocw = new eDocutool.Word();

            //wordPageContorol文書作成
            //初期設定
            string now = DateTime.Now.ToString("yyyyMMddHHmmssfffffff");//出力ファイルをユニークにするための年月日時分秒
            string docxFileName = @"..\..\baseRepFile\soft-kaihatsu.docx";//文書ファイル名
            string docxFileNameR = @"..\..\outRepFile\soft-kaihatsu_" + now + ".docx";//出力文書ファイル名

            //文書作成開始
            edocw.startPage(docxFileName);
            edocw.setAddPage();

            //Word文書内の文字置換処理
            edocw.setTextDataAll(target.Text, changeText.Text);

            //ページ終了
            edocw.endPage(docxFileNameR);

            //メッセージ
            result.Text = "文書出力が完了しました。";
            filePath.Text = edocw.OutFilePath;

            //解放
            edocw = null;
        }

        private void fileOpen_Click(object sender, EventArgs e)
        {
            //
            //作成したファイルを開く処理
            //

            //テキストボックス文字列のチェック
            if (filePath.Text != "")
            {
                FileInfo fi = new FileInfo(filePath.Text);
                if (fi.Exists)
                {
                    Process.Start(fi.FullName);
                }
            }
        }

        private void todofuken_SelectedIndexChanged(object sender, EventArgs e)
        {
            //全国の場合、Word-DataBindは動作しない設定
            if (todofuken.SelectedValue.ToString() == "00")//全国
            {
                wordPageControlBind.Enabled = false;
            }
            else
            {
                wordPageControlBind.Enabled = true;
            }
        }
    }
}
